; 
; 6812 monitor 1.9.2
;
; Feb 12, 2001 (v1.0?? v1.1??)
; Mar 21, 2001 updated (works fully) (v1.2?)
; Dec 10, 2001 (v1.3) added breakpoint stuff while in a motel in 
;              Tallahassee after visiting historic Doak Campbell 
;              Stadium at FSU. I'm not impressed. Their campus is 
;              so dirty. The inside of all their buildings looks like 
;              the basements of ours. Doak is big, tho. Seems bigger
;              than Ben Hill at UF but maybe I was imagining things.
; Dec 16, 2001 (v1.4) I'm changing the way the user interface works 
;              since I'm out of menu numbers (see v1.3 source.) It'll
;              now work mostly like the old 6811 Buffalo did. Must 
;              give them proper names :)
; Dec 18, 2001 (no version change) The command-line is working now.
;              change the version if any new options are added. ok?
;              Removed the breakpoint code because of continuing
;              debate over its usefulness. We don't know if using
;              SWIs is a good idea.
; Dec 18, 2001 (v1.4.1) This is an EXPERIMENTAL version for trying
;              to write a damn disassembler. If successful, it'll
;              become v1.5 (or higher.) v1.4 is still the "release"
;              version!
; Dec 22, 2001 (v1.5) Yes, I threatened to release the code with
;              a disassembler as v1.5 so here it is. The 
;              disassembler code is in disasm.asm which is included
;              herein using a directive at the bottom. I'm not quite
;              sure which opcodes it'll disassemble but I don't care 
;              to find out just yet. v1.5 is now the release version.
;              Now to add the breakpoint stuff back in ...
; Dec 22, 2001 (v1.6.1) Putting breakpoint stuff back. EXPERIMENTAL.
; Dec 23, 2001 (v1.7) All the breakpoint stuff is back! Works, too.
;              Ummm ... not much more than that. Yes, I skipped 
;              v1.6 because there have been so many changes since 
;              v1.5. Remember that breakpoints only work with
;              code in RAM. See the notes below about doing code
;              in flash.
;              Still some test code at the end that can be removed
;              if necessary.
; Dec 24, 2001 Fixed the bug in the resume function. Stack ptr
;              could keep decrementing if RES is called (via jsr)
;              and the user's SWIs keep happening (which doesn't
;              reset the monitor's SP.)
;              I used pre-processor commands to conditionally
;              compile all the debugging stuff. The bad thing 
;              is that ASM12 doesn't have a -D command-line
;              option! D'oh!
; Dec 26, 2001 I think I fixed all of the interrupt vectors and fake
;              user vectors for the 68HC12B32. It works, anyhow.
;
; Jan 28, 2002 (v1.8) Need to change the pseudo-interrupt vector table
;              to be like whats in the 6812B32 manual. (Correct, that is.)
;
; Feb 13, 2002 (v1.9) Turned off clock stretching by changing the MISC
;              register. It should be noted that the "old" commented
;              way of turning it off was the same. We had a failure of
;              communication. Also cleaned up the code a little. (The
;              old method used the MODE register. It doesn't work. The
;              MODE register ESTR bit can't be changed to turn off
;              clock stretching. You must use MISC to set zero 
;              stretches. 
;              I also made it so that the PEAR is read and OR'd 
;              rather than simply set.
; Feb 20, 2002 (v1.9.1) EXPERIMENTAL VERSION
;              Changed the download subroutine to handle S0 (header)
;              records.
; Mar 04, 2002 (v1.9.2) released the version 1.9.1 experimental changes
;              onto the world.
;
; Author   : Patrick O'Malley (POM) (pomalley@mil.ufl.edu)
; Place    : University of Florida/Machine Intelligence Lab
;            (code was written entirely on the author's laptop, however)
; Copyright: This code is freely distributed to the public under
;            the GNU Public License (GPL). It may be modified and
;            distributed (freely) as long as the original author's
;            (and anyone else's who modifies the code) name 
;            remains attached. And anyone may distribute a 
;            binary of this code as long as due credit is given
;            the author(s).
;            This author (POM) places another stipulation that
;            the notes section _must_ be distributed with the
;            source -- no removing it. Period. 
;
; Notes:
; Some of this code is ugly. The _ne subroutines, for
; example. These do no echo back to the screen. Why?
; because of some dumb stuff. They can all be removed
; if you really want. I'm too lazy. 
; 12/17/01: Removed the _ne subroutines. It'll make the
; download S19 routine messy because as it runs it'll be
; echoing the S19 to the screen but who cares? I just made
; space! (POM)
;
; Yes, there is a dumb bug in the view memory
; thing so that it prints out an extra "<address>:"
; Again -- too lazy to fix. (POM)
;
; This was written for the EEL4744 course which is/was
; changed over to the 6812 from the 6811. Yeah, a dumb
; change but whatever -- it wasn't my decision. (POM)
;
; For some strange reason, using the ASCII upload in 
; minicom for Linux will NOT work with the S19 
; downloader subroutine. However, just do a 
; "cat file.s19 > /dev/ttyS0" and it will work fine.
; I don't know why minicom messes up. (POM)
;
; This code will compile with the old 6811 assembler.
; Am I sure of this? No, not really. (POM)
;
; Before anyone asks (and they will) the S19 download routine
; will NOT dump code into EEPROM or FLASH! Got that? Firstly, 
; putting it into flash would be dumb and necessitates a 12v
; external "programming voltage". Secondly, for debugging, one
; should dump their code to RAM, run it and debug it there. Thats
; fast and easy. Anything else would be rather dumb. Oh, and I don't
; know how much EEPROM the thing has so I'm not going to write tons
; of code just to find out that it has 256 bytes that you can't run
; code out of anyhow! (POM)
;
; You know whats funny? I wasn't aware of some ops when I wrote this!
; Like "sts" -- had no idea! I had been using "tsx" then storing X!
; Thats like a RISC programmer to do something like that :) (POM)
;
; 
;
; -------- MISC EQUATES --------

PEAR		equ	$000A	; Port-E Assignment Register
MODE		equ	$000B
MISC		equ	$0013	


; -------------------= INTERRUPT VECTORS =--------------------
; The interrupt vectors are placed at $FFCE (in monitor ROM)
; on the 6812. To allow the monitor's user to be
; able to use the interrupts tho, we need to redirect them
; to a place where the user can modify them. To do that,
; "fake" vectors of 3 bytes are placed in the beginning
; of internal RAM ($0800). The hard-coded vectors are pointed
; to these ones where the user can put a JMP <addr> 
; instruction. One caveat, though: when the board is
; reset, those fake vectors (the JMP instructions) are
; uninitialized! The user must remember to add their own
; jmp instruction.
;
; The SWI and RESET vectors are hard-coded to go to 
; monitor code.


	org	$ffcc	
MOD_UNDER		dw	v_MOD_UNDER
	org	$ffca
PACB_OVER		dw	v_PACB_OVER
	org	$ffd0
BDLC			dw	v_BDLC
ATD			dw	v_ATD
RES4			dw	$0000
SCI0			dw	v_SCI0
SPI_TC			dw	v_SPI_TC
PAC_IN_EDGE		dw	v_PAC_IN_EDGE
PAC_OVER		dw  	v_PAC_OVER
TMR_OVER		dw	v_TMR_OVER
T7			dw	v_T7
T6			dw	v_T6
T5			dw	v_T5
T4			dw	v_T4
T3			dw	v_T3
T2			dw	v_T2
T1			dw	v_T1
T0			dw	v_T0
RTI			dw	v_RTI
IRQ			dw	v_IRQ
XIRQ			dw	v_XIRQ
SWI			dw	swi_handler	; the monitor needs this vector
TRAP			dw	v_TRAP
COP_FAIL		dw	v_COP_FAIL
COP_CLK_FAIL		dw	v_COP_CLK_FAIL
RESET			dw	$e000		; and this one too


; ---- FAKE INTERRUPT VECTORS! ----

	org	$0800

v_MOD_UNDER		zmb	3
v_PACB_OVER		zmb	3
v_BDLC			zmb	3
v_ATD			zmb	3
v_SCI0			zmb	3
v_SPI_TC		zmb	3
v_PAC_IN_EDGE	zmb	3
v_PAC_OVER		zmb	3
v_TMR_OVER		zmb	3
v_T7			zmb	3
v_T6			zmb	3
v_T5			zmb	3
v_T4			zmb	3
v_T3			zmb	3
v_T2			zmb	3
v_T1			zmb	3
v_T0			zmb	3
v_RTI			zmb	3
v_IRQ			zmb	3
v_XIRQ			zmb	3
v_SWI			zmb	3
v_TRAP			zmb	3
v_COP_FAIL		zmb	3
v_COP_CLK_FAIL	zmb	3
v_RESET			zmb	3

; ----------- MONITOR VARIABLES -------------
tempw		dc.w		$0000
tempw2		dc.w		$0000
bkpt_table	zmb		10		; the addresses of the breakpoints
bkpt_tbl_code	zmb		5		; the code that used to be where the SWIs are now
SP_save		dc.w		user_stack_top	; a place to save the user's SP when SWI occurs
SP_save_mon	dc.w		$0000		; a place to save the monitor's SP (why??)
cmd_buffer	zmb		cmd_buffer_size	; where the user's command is put!
cmd_buffer_size	equ		20		; I didn't know where to put this!

bkpt_state	dc.b		$00		; state of the bkpt code (see SWI handler)
bkpt_addr	dc.w		$0000		; where to put the bkpt back
bkpt_addr2	dc.w		$0000		; where the "second" bkpt is (for break - )
bkpt_code	dc.b		$00		; code to put back where the second SWI is

#ifdef	__DEBUG__
ram_code_test	zmb		10

end_of_ram	equ		*
#endif

; the monitor's stack is 32 bytes (should be enough)
; and is located here, at the top of the internal RAM.
; user stack can be just below it. user_stack_top
; is here just for reference! its never used specifically!

	org	$0bff
mon_stack_top	equ	*

	org	$0bdf
user_stack_top	equ	*

	
; -----=-=-=-= MONITOR RESET ENTRY =-=-=-=-----
; RESET ENTERS HERE!

	ORG		$E000

	lds		#mon_stack_top		; setup the stack pointer
	jsr		cop_off			; turn off the COP reset gen
	jsr		init_serial_tx_rx	; start the serial system, duh.

	; since SP_save is in RAM and we don't control that, lets
	; make sure its OK by putting the address of user_stack_top 
	; into SP_save

	ldx		#user_stack_top
	stx		SP_save

	; clear the bkpt state (just in case)
	clra
	staa		bkpt_state	

	; clear the bkpt table
	ldaa		#10
	ldx		#bkpt_table
	clrb
b_loop2:
	stab		0,x
	inx
	deca
	bne		b_loop2
		
; the following code turns off the clock stretching the right way
; v1.9 code change
	ldaa		MISC
	anda		#%11110011
	staa		MISC

	; the next two lines enable RAM R/W
	; or it won't work!
	ldaa		PEAR
	oraa		#%00000100	; enable R/W
	staa		PEAR

#ifdef 	__DEBUG__
	; need to move test code into RAM to test bkpt stuff
	ldab		#(testcode - tc_end)
	ldx		#testcode
	ldy		#ram_code_test
b_loop1:
	ldaa		0,x
	staa		0,y
	inx
	iny
	decb
	bne		b_loop1	
#endif

; print the splash screen and the menu
begin:
	; print the splash once and only once!
	jsr		print_splash
begin_1:
	ldy		#newline
	jsr		print_string
	; print the prompt
	ldaa		#'>'
	jsr		put_char
	ldaa		#' '
	jsr		put_char
	; use get_line to get a line from the user
	ldx		#cmd_buffer
	ldab		#20			; B holds the max # of chars a user can enter
	jsr		get_line
	jsr		parse_command_line	; parse the command line. returns addr of sub in X, returns addr of 
						; end of cmd string in cmd buffer in Y
	iny					; actually we need to inc Y to get past the end of the cmd buffer
	cpx		#cmd_buffer		; if there was an error, X will be #cmd_buffer	
	beq		begin_1			; if error, just go back to prompt
	jsr		0,x			; otherwise jump to the sub
	bra		begin_1			; and return to beginning


; ----------- TEXT ------------
; I had to put it somewhere ...

msg_1		dc.b	"Monitor v1.9.2 (c)2001 POM/U. Florida",13,10,0
newline		dc.b	13,10,0

em_2		dc.b	"Old value: ",0
ds_wait		dc.b    13,10,"Waiting for S19 download ... ",0
ds_done		dc.b	"done!",13,10,0
go_addr_msg	dc.b	"Address: ",0
error_msg	dc.b	13,10,"you missing something?",13,10,0
dis_incom_msg	dc.b	13,10,"incomplete disassembly ...",13,10,0
bkpt_err	dc.b	"no empty breakpoint slots",13,10,0

; ------ prompt command table ------

cmd_start	dc.b	2			
vm_cmd		dc.b	"md"				; memory display (formerly memory view)
		dc.w	view_mem_sub

		dc.b	2
		dc.b	"go"				; "go" or jmp to user code
		dc.w	go_addr_sub

		dc.b	4
		dc.b	"help"				; duh
		dc.w	help_sub

		dc.b	2
		dc.b	"mm"				; memory modify
		dc.w	edit_mem_sub

		dc.b	4	
		dc.b	"fill"				; block fill
		dc.w	block_fill_sub

		dc.b	4
		dc.b	"load"				; S19 download
		dc.w	download_sub

		dc.b	2
		dc.b	"rv"				; register view
		dc.w	reg_view_sub
	
		dc.b	2
		dc.b	"rm"				; register modify
		dc.w	reg_edit_sub

		dc.b	5
		dc.b	"break"				; breakpoint stuff
		dc.w	break_sub

		dc.b	3
		dc.b	"res"				; resume after SWI bkpt
		dc.w	resume_sub

		dc.b	4
		dc.b	"test"				; test code for the 4744 board?
		dc.w	test_sub

		dc.b	4
		dc.b	"dasm"
		dc.w	dis_assembly_sub		; disassembler

		dc.b	1
cmd_end		dc.b	"blank"				; this has to be here -- don't remove


; -----------------=-=-=-= SUBROUTINES =-=-=-=----------------------


; ----------------------= PARSE COMMAND =-----------------------
; parse_command_line converts the user's input to an address 
; where to jump to the subroutine corresponding to that the 
; user wants. I could have said that a lot better :) I'm lazy.
; --------------------------------------------------------------
parse_command_line:
	pshx					; X is the command buffer
	ldy		#cmd_start		; Y will point to the command list
	ldaa		0,y			; A will be the length of this command from the list
	iny					; Y now points to the text of the command
pcl_loop1:
	ldab		0,y			; load the next letter of the command
	cmpb		0,x			; compare it to the command buffer
	bne		pcl_nomatch		; if not equal, go to the next command

	deca					; decrement the counter of # of letters in this command
	beq		pcl_cmd_ok		; if we got here, this is the command we want!

	inx					; need to advance the pointers to the commands
	iny					
	bra		pcl_loop1		; continue the comparing
pcl_nomatch:
	pulx					; restore X (beginning of command buffer)
	pshx					; save for later

	; need to move to next command in list
	psha
	pulb					; put A (length of command in list) into B
	addb		#2			; add 2 to get past address of command
	aby					; add B to Y (to get to end of this command)
	ldaa		0,y			; load the length of the next command
	iny

	; check to see if we're at the end of the command list
	cpy		#cmd_end		
	beq		pcl_abs_nomatch		; absolutely no match

	bra		pcl_loop1		; do it again!
pcl_cmd_ok:
	; we're at the end of the command (Y) so get the address there!
	pshx					; X is the end of the cmd in the cmd buffer
	iny
	ldd		0,y			; D has the address of the sub
	xgdx					; put it in X
	puld					; D = end of cmd in cmd buffer
	puly					;		
	xgdy					; put the end of the cmd in the buffer into Y
	rts	
pcl_abs_nomatch:
	ldy		#error_msg
	jsr		print_string
	pulx					; X has the location of the buffer in it now on error
	rts


; -----------------= SWI SUBROUTINE! =----------------------
; this is where the SWI interrupt gets processed
; breakpoint stuff here?
; we need to do several things here:
; 1. save user stack and start using the monitor's stack
; 2. replace the SWI at the addr with the code that was 
;    there. This means we need to search the bkpt table
;    for that address
; 3. place an SWI at the next instruction and save its
;    code. 
; 4. jmp to monitor beginning
;
; remember we need to make a state variable and check it
; at the entry to this subroutine.
; There are two states:
; 1. First SWI just happened
;       Need to do the above
; 2. Second SWI just happened
;       put the first SWI back
;       replace this SWI with original code
;
; I was thinking about what happens if a USER puts SWIs 
; manually into their code (this is actully a really good
; debugging idea). My monitor code would confuse it with 
; the first SWI of a breakpoint. However, if, during the
; first SWI handler it doesn't find a breakpoint in the 
; table corresponding to this location, it will now 
; assume its a user-supplied SWI.
; ----------------------------------------------------------
swi_handler:
	; copy the SP (user's SP) to the RAM location for it
	sts		SP_save			; forgot this instruction!

	; change SP to the monitor's SP	
	lds		SP_save_mon		; I wonder if this is really necessary

	; check the state variable if its zero, this is the first SWI
	; if not, its the second
	ldaa		bkpt_state
	beq		sh_first_swi

	; if code is here, its the second SWI (the one that restores the original)
	ldx		bkpt_addr		; addr of where to put the SWI back
	ldaa		#$3f
	staa		0,x
	ldx		SP_save
	ldd		7,x			; RTN addr
	subd		#$01
	std		7,x			; put it back
	xgdx
	ldaa		bkpt_code
	staa		0,x
	clra		
	staa		bkpt_state
	
	lds		SP_save
	rti

sh_first_swi:
	; this is the first SWI so we need to figure out which of the breakpoints
	; it was. the way to do this is by getting the PC off the user's stack
	; and searching for that addr-1 in the bkpt table
	ldx		SP_save			; X=ptr to user's stack
	ldab		#$07
	abx					; the RTN addr is 7th byte on the stack!
	ldd		0,x			; RTN addr is 2 bytes on stack
	subd		#$01			; subtract 1
	pshd					; save it for a bit -- need it again later

	; now search for that addr in D in the bkpt table
	jsr		sh_search_addr		; returns offset into table in A (bkpt number)
	cpx		#$0000			; if this is returned, the addr wasn't found
	beq		sh_user_bkpt		; and its a user SWI

	ldx		#bkpt_tbl_code		
	psha
	pulb
	abx					; addr+offset = location of code
	ldaa		0,x			; get the code
	pulx					; X=loc of SWI in code
	staa		0,x			; save the old code
	
	; now we need to make it such that the return addr on the user's
	; stack goes to addr-1 (currently in X)
	xgdx					; put it in D
	ldx		SP_save
	pshb
	ldab		#$07
	abx
	pulb
	std		0,x			; put the modified return addr in 

	; now we need to put an SWI at the beginning of the next instruction after
	; the current one (addr of which is in D)
	xgdx					; move addr into X
	stx		bkpt_addr		; save that addr (to put the first SWI back)
	jsr		disasm			; moves X to beginning of next instr
	ldaa		0,x			; get code there
	stx		bkpt_addr2		; save the loc of the second swi (for break -)
	staa		bkpt_code		; save it
	ldaa		#$3f
	staa		0,x			; put an SWI there
	staa		bkpt_state		; put anything > 0 there	
	
	; jump to the monitor code
	jmp		begin_1

sh_user_bkpt:
	puld					; we had saved it
	jmp		begin_1


; in: D = addr to find in bkpt table
; out: X = addr of addr in bkpt table
; out: A = offset into bkpt table (number of bkpt)
sh_search_addr:
	pshd
	clr		tempw			; used as a counter
	puld
	ldx		#bkpt_table
sh_loop1:
	cpd		0,x			; D==[X]?
	beq		sh_foundit
	inx
	inx
	inc		tempw			; increment our counter
	psha
	ldaa		#$05			; 5 bkpt entries
	cmpa		tempw		
	beq		sh_done_notfound
	pula
	bra		sh_loop1
sh_foundit:
	ldaa		tempw			; count of offset into bkpt table where 
						; the addr was found
	rts
sh_done_notfound:
	pula
	ldx		#$0000			; error code
	rts	

; ----------------=TEST DEBUG SUBROUTINE =-------------------
; currently this code does nothing. in the final version,
; however, we may wish to use it to test the entire 6812
; board rather than having a special "test" ROM. This way
; the test code may be able to tell whats wrong and the 
; student can attempt to debug using the other subs.
; -----------------------------------------------------------
test_sub:
	jsr		parse_address
	cmpb		#$ff			; look for error!
	beq		test_error
	jsr		print_address		; test parse_address and print it
	rts
test_error:
	ldy		#error_msg
	jsr		print_string
	rts

; --------------= DISASSEMBLY SUB =--------------------
; This code disassembles <n> instructions beginning
; at a particular address. 
; Note that whereas X is the addr of the op you want
; disassembled, after disasm is called, X 
; points to the next op!
; -----------------------------------------------------
dis_assembly_sub:
	jsr		parse_address		; returns addr in X
	cmpb		#$ff
	beq		das_error
	jsr		parse_byte		; returns in A
	cmpb		#$ff
	beq		das_error
das_loop1:
	psha		
	jsr		disasm			; disassemble it
	cmpb		#$ff
	beq		das_incomplete
	pula
	deca
	bne 		das_loop1
	bra		das_done

das_incomplete:
	pula	
	ldy		#dis_incom_msg
	jsr		print_string
	bra		das_done
das_error:
	ldy		#error_msg
	jsr		print_string
das_done:
	rts



; ----------------= VIEW MEMORY SUBROUTINE =---------------
; displays in 16-byte lines the contents of memory
; between two addresses.
; ---------------------------------------------------------
view_mem_sub:
	jsr		parse_address		; returns low address in X
	cmpb		#$ff			; error?
	beq		vms_error
	stx		tempw			; store it for later	

	jsr		parse_address		; returns high addr in X
	cmpb		#$ff			; error?
	beq		vms_error
	ldy		tempw			; Y is now the low addr
	
	sty		tempw			; put it into a temp var to compare it to X
	cpx		tempw			; compare X (high addr) to tempw (low addr)
	ble		vms_done		; if high addr < low addr then its an error!

	stx		tempw			; put X (high addr) in var for later
	pshy
	pulx					; X is now the low addr

	pshx					; yes, I realize this is dumb but I have to do it

	ldx		tempw			; get high address
	puld					; D is low addr

	;jsr		print_address		; DEBUG

	; round down the lower address
	andb		#%11110000
	xgdx	
	; round up the upper address (in D right now)
	pshd
	andb		#%00001111
	ldaa		#$0f
	sba
	adda 		#1
	psha					; such a damn hack
	pulb					;
	clra					;
	std		tempw2
	puld	
	addd		tempw2

	std		tempw			; store D -- the upper address

	;xgdx					; D is now the lower and X the upper

loop1:
	ldy		#newline
	jsr		print_string
	
	jsr		print_address
	ldaa		#':'
	jsr		put_char
	ldaa		#32
	jsr		put_char
loop2:
	cpx		tempw
	beq		vms_done

	ldaa		0,x			; load the number at the location
	jsr		print_number
	ldaa		#32			; space
	jsr		put_char

	pshx
	puld	
	andb		#%00001111
	cmpb		#$0F
	beq		vms_newline
	bra		vms_blah	
vms_newline:
	inx
	bra		loop1
vms_blah:
	inx	
	bra		loop2
vms_done:
	ldy		#newline
	jsr		print_string
	rts
vms_error:
	ldy		#error_msg
	jsr		print_string
	rts

;--------------------= "GO" SUBROUTINE =---------------------
; The "go" routine just does a JMP to where the user says. It 
; doesn't mess with the stack (other than to set SP to the 
; user's stack) the "resume" function does an rts using the 
; stack to get to user's code after an SWI, for example. Use 
; that for breakpoints.
; -----------------------------------------------------------
go_addr_sub:
	jsr		parse_address		; returns what we want in X

	ldy		#newline
	jsr		print_string

	pshx
	puly					; put the address in Y		

	; save the monitor's stack. set SP to user's
	sts		SP_save_mon

	lds		SP_save
	
	; now jump to the location in Y
	jmp		0,y

;-----------------= "RESUME" SUBROUTINE =---------------------
; put SP back to the user's stack and do an rts!
; but save the monitor's stack!
; ------------------------------------------------------------
resume_sub:
	
	ins					; because RES was called as a JSR,
	ins					; we need to increment the mon stack ptr
						; so that it doesn't keep creeping down	

	sts		SP_save_mon		; save the monitor's stack
	lds		SP_save			; SP = [SP_save] (SP gets the user's stack ptr)

	rti					; rti will resume the user's code


; -----------------= EDIT MEMORY SUBROUTINE =------------------
; should be called memory modify. changes memory at addr by
; putting <val> in there.
; cmd: mm <addr> <val>
; -------------------------------------------------------------
edit_mem_sub:
	
	pshy 					; these are just to save the regs from modification
	pshx					;
	pshd					;
	
	jsr		parse_address		; returns address in X
	cmpb		#$ff			; error?
	beq		em_done			; if yes, done
     
	ldaa		0,x			; get the old value
	psha					; save for later use	

	jsr		parse_byte		; returns byte in A
	cmpb		#$ff			; error?
	beq		em_done_up		; yes, quit

	psha					; print_string doesn't preserve A it would seem!
	ldy		#newline
	jsr		print_string
	ldy		#em_2			; "Old value: "
	jsr		print_string
	pula					; restore A

	pulb					; pull the old value from the stack
	psha					; push the new value
	pshb
	pula					; a = old value
	jsr		print_number		; print the old value	

	pula					; pull the new value off

	staa		0,x			; put the new number into
						; that memory location
	bra		em_done

em_done_up:
	pula					; we need to pull A because it was put on

em_done:
	puld					; restore the registers
	pulx
	puly 

	rts					; done

; ------------------= BLOCK FILL SUBROUTINE =-------------------
; fills memory from a low addr through a high address with
; a constant value.
; cmd: fill <addr1> <addr2> <val>
; --------------------------------------------------------------
block_fill_sub:
	pshy
	pshx
	pshd

	pshy					; push Y because we need it
	ldy		#newline		;
	jsr		print_string		;
	puly     				; restore the cmd buffer addr in Y
 						; restore the cmd buffer addr in Y
	jsr		parse_address		; returns addr in X
	cmpb		#$ff			; error?
	beq		bf_derr			;
	pshx					; store it

	jsr		parse_address		; returns end addr in X
	cmpb		#$ff			; error?
	beq		bf_done1		; special done	
	pshx					; and put it away

	jsr		parse_byte		; gets a byte from the cmd line ret in A
	cmpb		#$ff			; error?
	beq		bf_done2		; yes!

	pulx					; pull off the high address (end)
	psha					; save it (the fill number)
	xgdx					; D is now the high addr
	std		tempw			; save it in RAM
     
	pula					; restore it (the number to fill with)
	pulx					; the low addr (get the low addr)

bf_loop:
	staa		0,x			; put the number into mem
	inx					;
	cpx		tempw			; compare it with memory
	bgt		bf_done			; branch to done if >= end addr
	bra		bf_loop			; otherwise continue

bf_done2:
	pulx					; get everything off the stack
bf_done1:
	pulx					; gets rid of the stuff on the stack
bf_derr:
	ldy		error_msg		; print an error message!
	jsr		print_string		;
bf_done:
	puld
	pulx
	puly
	rts

; --------------= Print Breakpoint Table Sub =-------------
; yeah, I know this is out of place!
; ---------------------------------------------------------
print_bkpt_sub:
	ldy		#newline
	jsr		print_string

	ldab		#$05			; load the bkpt counter
	
	ldx		#bkpt_table
	ldy		#bkpt_tbl_code		
	
pb_loop1:
	pshb					; save the counter
	ldd		0,x			; load the address in the table
	xgdx					; d <-> x
	jsr		print_address		; print the address
	xgdx	

	ldaa		#32			; space
	jsr		put_char
	
	ldaa		0,y			; a is now the code it replaced
	jsr		print_number		; print it

	pshy
	ldy		#newline		
	jsr		print_string	
	puly

	inx					; X needs to increment two each time
	inx
			
	iny					; Y only needs to increment once

	pulb					; get the counter back
	
	decb					
	beq		pb_done			; zero?
	bra		pb_loop1
pb_done:
	rts


; -----------------= breakpoint subroutine =----------------
; don't know how well subs will work but we can see
; so how is this going to work? I'm thinking that 
; I'll first find the end of the instruction at 
; the breakpoint addr and put an SWI there, too. Then, when
; the first SWI happens, you can continue and when the 
; second SWI happens you can replace the first :)
; ----------------------------------------------------------
break_sub:
	jsr		skip_wspace		; why do this?
	ldaa		0,y
	iny
	;jsr		skip_wspace	

	cmpa		#'+'
	beq		jsr_bkpt_add
	cmpa		#'-'
	beq		jsr_bkpt_sub
	
	jsr		print_bkpt_sub		; if its neither, print the table
	rts

jsr_bkpt_sub:
	jsr		bkpt_sub
	rts
jsr_bkpt_add:
	jsr		bkpt_add
	rts
bs_error:
	ldy		#error_msg
	jsr		print_string
	rts

; bkpt_add -- routine to add breakpoints
bkpt_add:
	jsr		parse_address		; get the addr where we want this SWI	
						; returns in X
	cmpb		#$ff
	beq		ba_error		; return with error code

	pshx					; save the bkpt addr

	jsr		bp_get_empty		; returns addr in X, offset in A
	cmpa		#$ff			; no empties?
	beq		ba_no_empty
	
	puly					; Y=bkpt addr
	sty		0,x			; put it into the table

	ldx		#bkpt_tbl_code		
	psha
	pulb
	abx	
	ldaa		0,y			; get the code
	staa		0,x			; save it

	ldaa		#$3f
	staa		0,y			; put the SWI there
	
	rts					; and done!

ba_no_empty:
	ldy		#bkpt_err
	jsr		print_string
ba_error:
	ldab		#$ff	
	rts

; bpge_get_empty -- finds an empty bkpt table entry
; in: nothing
; out: X -- addr of first empty bkpt table entry
; out: A -- offset of that entry in the table (bkpt number)
;      A -- $ff on error (no empty entry)
bp_get_empty:
	ldx		#bkpt_table
	clra	
bpge_loop1:
	psha
	ldd		0,x			; get this entry
	beq		bpge_empty		; its empty!
	inx
	inx					; move to the next one
	pula
	inca
	cmpa		#$05			; five entries
	beq		bpge_no_empty		; no empty entry
	bra		bpge_loop1		; otherwise continue
bpge_no_empty:
	ldaa		#$ff
	rts
bpge_empty:
	pula
	rts


; bkpt_sub -- routine to remove breakpoints
bkpt_sub:
	jsr		parse_address		; returns in X
	cmpb		#$ff
	beq		ba_error

	; we need to search the bkpt table for this addr
	xgdx					; put the addr in D
	jsr		sh_search_addr		; returns offset in A, addr in X

	cpx		#$0000			; if not found, X=0000
	beq		bsub_not_a_bkpt		; on error

	psha					; save them for a minute
	pshx

	ldaa		bkpt_state		; state of the bkpt system
	cmpa		#$00			; if $00, then we're not "between" SWIs
	beq		bsub_not_between

	; when we're here, we need to not only change the bkpt table, we need to
	; replace the "second" SWI with the code thats supposed to be there!
	ldx		bkpt_addr2		; addr of the second SWI
	ldaa		bkpt_code		; and the code to go there
	staa		0,x			; restore the code
	clra		
	staa		bkpt_state		; clear the state so it doesn't do strange things

bsub_not_between:
	; all we need to do here is replace the "first" SWI with the code
	; thats supposed to be there and remove that bkpt from the table
	; remember to zero it out!
	pulx					; addr of this bkpt in the table
	pulb					; offset in the table
	pshx					; save that addr
	
	ldy		0,x			; get the addr of this bkpt
	ldx		#bkpt_tbl_code	
	abx
	ldaa		0,x
	staa		0,y			; restore the code
	
	pulx
	ldd		#$0000			; 
	std		0,x			; zero that entry in the bkpt table
	rts

bsub_not_a_bkpt:
	rts

	


; ------------------= Help Subroutine =--------------------
; display command help information
; ---------------------------------------------------------
; the help string to print follows:
;
help_str:
	dc.b "md <addr> <addr>           : display memory between <addr1> and <addr2>",13,10
	dc.b "rv                         : display contents of registers after SWI",13,10
	dc.b "rm <reg>                   : modify contents of <reg> where reg=<cbaxyp>",13,10
	dc.b "load                       : download S19 to RAM",13,10
	dc.b "mm <addr> <val>            : modify memory location <addr> with value <val>",13,10
	dc.b "fill <addr1> <addr2> <val> : fill between <addr1> and <addr2> with <val>",13,10
	dc.b "go <addr>                  : begin executing user code at <addr> (jmp)",13,10
	dc.b "res                        : resume execution after SWI",13,10
	dc.b "break [+][-][<addr>]       : add/remove/view breakpoints",13,10
	dc.b "dasm <addr> <ops>          : disassemble <ops> instructions starting at <addr>",13,10,0
help_sub:
	ldy		#help_str
	jsr		print_string

	ldy		#newline
	jsr		print_string	

	rts


; -------------= Register Modify Subroutine =--------------
; this subroutine modifies the registers on the user stack. 
; for use after an SWI.
; ---------------------------------------------------------
reg_edit_sub:
	jsr		skip_wspace
	ldaa		0,y			; get the name of the register we want to edit
	
	iny	
	pshy					; save it for later to get byte/word to put in reg	

	clrb					; B will be the offset counter into the regs on the stack
	ldx		#reglist		; X will be used as a pointer to the reglist (to compare to A)
	ldy		#rl_size		; Y will be used to check the size of the regs to increment B

re_loop1:
	cmpa		0,x			; is the reg we're looking for in 0,x (reglist)?
	beq		re_gotit		; yes, we got it

	psha					; no, increment x, y, b (with correct # of bytes)
	ldaa		0,y
	cmpa		#$00			; is it a byte?
	beq		re_bs1				
	incb					; no, add two to B
re_bs1:					
	incb					; yes, just add one
	pula					; restore A
	inx
	iny					
	cpx		#rl_size		; did we get to the end of the reglist and not find it?
	beq		re_error		; yes, then its an error
	bra		re_loop1		; no, lets continue
re_gotit:
	; at this point B is the offset into the user's stack and [0,y] tells us how 
	; big it is. X is unnecessary.
	ldx		SP_save			; load X with the user's stack pointer
	abx					; add B to X to get a pointer to what we need
	ldaa		0,y			; load A with the size byte
	cmpa		#$00			; is it a byte?
	beq		re_bs2			; yes, then do something different

	
	puly					; restore the loc in the cmd buffer
	pshx					; save the addr
	jsr		parse_address		; get the new value for this register (ret in X)
	cmpb		#$ff			; error?
	beq		re_error
	puly					; restore the addr in the user's stack
	stx		0,y			; save the new value to [0,y]
	bra		re_done
re_bs2:
	puly					; restore the loc in the cmd buffer
	jsr		parse_byte		; get the number to put in the reg
	cmpb		#$00			; error?
	beq		re_done			; yep -- just go.
	staa		0,x
	bra		re_done
re_error:
	puly
re_done:
	rts


; --------------= Register View Subroutine =---------------
; this subroutine displays the registers stored on the 
; user's stack after (for example) an SWI.
; ---------------------------------------------------------
reglist	dc.b	'cbaxyp'
rl_size	dc.b	0,0,0,1,1,1

reg_view_sub:

	ldy		#newline
	jsr		print_string

	ldy		SP_save			; load Y with the user's SP
	ldx		#reglist		; load X with the stuff we need to use
	ldaa		#6
rv_loop1:
	ldab		6,x			; load B with the size of the register to be printed
	cmpb		#$00			; 
	bgt		rv_double		; if its a '1' its a double!
rv_single:
	psha
	ldaa		0,x
	jsr		put_char
	ldaa		#'-'
	jsr		put_char
	ldaa		0,y
	jsr		print_number
	pula
	iny
	inx
	bra		rv_loop_end
rv_double:
	psha
	ldaa		0,x
	jsr		put_char
	ldaa		#'-'
	jsr		put_char
	pula
	pshx
	ldx		0,y
	jsr		print_address
	pulx
	iny
	iny
	inx
rv_loop_end:
	psha
	ldaa		#32
	jsr		put_char
	pula
	deca
	beq		rv_done
	bra		rv_loop1
rv_done:
	rts

; --------------= S19 DOWNLOAD Subroutine =----------------
; puts an S19 file into memory. gets it from SCI
; ---------------------------------------------------------
download_sub:
	ldy        #ds_wait			; "waiting for S19 download"
	jsr        print_string			;

	; wait for S
S_wait:
	jsr        get_char_wait_noecho
	cmpa       #'S'
	bne        S_wait

	; wait for a '1' but exit if 9
one_wait:
	jsr        get_char_wait_noecho
	cmpa       #'9'
	beq        d_done
	cmpa       #'0'				; handle S0 records
	beq        zero_header
	cmpa       #'1'
	bne        one_wait

	; get the count and remove 3 for chksum and address
	; it is returned in A
	jsr        get_byte
	suba       #3
	; put it into B
	psha
	pulb

	; get the address (4 bytes)
	; it is returned in X
	jsr        get_address

d_loop1:
	; get the stuff!
	jsr        get_byte
	; store it
	staa       0,x

	; increment X -- address
	inx
	; decrement B and check if it is zero
	decb
	beq        S_wait
	bra        d_loop1
zero_header:
	jsr        get_byte
	suba       #3
        psha
        pulb
        jsr        get_address			; the address in headers is ignored

zh_loop:
	cmpb       #$00
	beq        zh_done
        jsr        get_byte			; this byte is meaningless so ignore
        decb
	bra        zh_loop
zh_done:
	jsr        get_byte			; the checksum
	bra        S_wait

d_done:
	ldy        #ds_done
	jsr        print_string
	rts

;--------- UTILITY ROUTINES! -----------

; return user address input in X
;
get_address:
	pshb
	bsr		get_number
	lsla	
	lsla
	lsla
	lsla
	psha
	bsr		get_number
	pulb
	aba	
	psha
	bsr		get_number
	lsla
	lsla
	lsla
	lsla
	psha
	bsr		get_number
	pulb					
	aba
	psha
	pulb
	pula
	xgdx	; put address in X
	pulb
	rts


; skips over whitespace chars in buffer pointed to by Y
; returns an error code in B if we skip too much!
skip_wspace:
	ldab		#5			; we'll skip a max of 5 chars. error if more.
sw_loop1:
	ldaa		0,y
	cmpa		#'+'-1
	ble		is_wspace		; if it is wspace, don't return -- keep going
	rts					; if not, return -- we've found good stuff
is_wspace:
	iny
	decb
	beq		ret_error
	bra		sw_loop1		; keep skipping wspace
ret_error:
	ldab		#$ff			; error code
	rts

; parse_byte parses command buffer in Y for a two-char (and only two-char) byte which
; is returned in A; error returned in B (if one)
parse_byte:
	; first skip whitespace
	jsr		skip_wspace
	cmpb		#$ff			; check for error!	
	beq		pb_error		; if error, just return!

	pshb
	bsr		parse_number
	lsla
	lsla	
	lsla
	lsla	
	psha
	bsr		parse_number
	pulb
	aba
	pulb
pb_error:
	rts

; parse_address just parses out an address (4 bytes) from the command buffer
parse_address:
	jsr		skip_wspace
	cmpb		#$ff
	beq		pa_error

	bsr		parse_byte		; returns in A
	psha		
	bsr		parse_byte		; returns in A

	; note that A is the MSB of D
	psha	
	pulb
	pula
	; D is now the number we want to return in X
	xgdx
pa_error:
	rts

; like get_number, this one gets a byte from the command buffer (Y)
; and converts it to binary from ascii. returns in A
parse_number:
	ldaa		0,y
	cmpa		#$39
	bgt		pn_alpha
	suba		#$30
	bra		pn_overalpha
pn_alpha:
	anda		#$0f
	adda		#9
pn_overalpha:
	iny					; move to next char
	rts


; Now this get_number subroutine actually returns a
; single hex number 0-15. It does not do a hex
; double -- that is the get_byte subroutine.
get_number:
	jsr		get_char_wait
	cmpa	#$39
	bgt		alpha_	
	suba	#$30
	bra		over_alpha_
alpha_:
	;suba	#55
	anda	#$0f
	adda	#9
over_alpha_:
	rts

print_splash:
	ldy		#newline
	jsr		print_string
	ldy		#msg_1
	jsr		print_string
	ldy		#newline
	jsr		print_string
	rts

; get_byte
; waits for two numbers (in hex)
; to be entered and returns the
; result in A
get_byte:
	pshb
	bsr		get_number
	lsla
	lsla	
	lsla
	lsla	
	psha
	bsr		get_number
	pulb
	aba
	pulb
	rts


; get_line subroutine gets a line of text from the serial port
; and puts it in a buffer starting at the address in X. The
; "end of line" is a CRLF (13,10). You can prevent buffer overflows
; by making B = # of chars that, if the user enters that many, will
; automatically cause this sub to return
get_line:
	jsr		clear_cmd_buffer
	pshx					; lets push X to keep it unchanged so you could print it
	pshb					; keep B unchanged
gl_loop1:
	jsr		get_char_wait		; returns the character in A
	staa		0,x			; otherwise store it in X
	inx					; increment X
	cmpa		#13			; only need to check for a 13 (LF)
	beq		gl_done			; if its a 13, return
	decb					; decrement B -- the line-length counter
	beq		gl_done			; if its zero, it means the user has entered enough. done.
	bra		gl_loop1		; continue
gl_done:
	inx
	clra		
	staa		0,x			; put a zero at the end of the line to indicate eol
	pulb					; restore B
	pulx					; restore X
	rts

; we need to clear the command buffer before each command input. I think.
clear_cmd_buffer:
	pshx
	pshd
	ldx		#cmd_buffer
	clrb		
	ldaa		#cmd_buffer_size
ccb_loop1:
	stab		0,x
	inx
	deca
	beq		ccb_done
	bra		ccb_loop1
ccb_done:
	puld
	pulx
	rts

#ifdef	__DEBUG__
; ----- TEST CODE! -----
; tests SWI and disassembler
; remove in production
testcode:
	ldab		#20
tc_loop1:
	swi
	ldy		#error_msg
	jsr		print_string
	decb		
	bne		tc_loop1
tc_end	equ		*
#endif


#include "disasm.asm"

#include "serial.asm"

#include "cop.asm"
