; 
; 6812 monitor 1.0
; Feb 12, 2001
; Mar 21, 2001 updated (works fully)
; Patrick O'Malley
; University of Florida/Machine Intelligence Lab
; 
; Notes:
; Some of this code is ugly. The _ne subroutines, for
; example. These do no echo back to the screen. Why?
; because of some dumb stuff. They can all be removed
; if you really want. I'm too lazy. 
;
; Yes, there is a dumb bug in the view memory
; thing so that it prints out an extra "address:"
; Again -- too lazy to fix.
;
; This was written for the EEL4744 course which is/was
; changed over to the 6812 from the 6811. Yeah, a dumb
; change but whatever -- it wasn't my decision.
;
; For some strange reason, using the ASCII upload in 
; minicom for Linux will NOT work with the S19 
; downloader subroutine. However, just do a 
; "cat file.s19 > /dev/ttyS0" and it will work fine.
; I don't know why minicom messes up.
;
; This code will compile with the old 6811 assembler.
;

	org		$FFFE

RESET		dw	$E000

PEAR		equ	$000A	; Port-E Assignment Register
MODE		equ	$000B


; ---- START ----

	org		$0800

; temporary storage space
tempw		dc.w		$0000
tempw2		dc.w		$0000
	
	org		$e000

	lds		#$0bff			; setup the stack pointer
	jsr		cop_off			; turn off the COP reset gen
	jsr		init_serial_tx_rx

	ldaa		MODE
	anda		#%11101111
	staa		MODE
		
	; the next two lines enable RAM R/W
	; or it won't work!
	ldaa    #%00000100      ;Enable R/W
	staa    PEAR

; print the splash screen and the menu
;
begin:
	jsr		print_splash
	jsr		print_menu
	jsr		get_selection	; returns a selection in A

	cmpa	#$31			; view memory
	beq		view_memory		
	cmpa	#$32			; edit memory
	beq		edit_memory		;
	cmpa	#$33			; block fill 
	beq		block_fill		;
	bra		download		; if all else fails!

view_memory:
	jsr		view_mem_sub
	bra		begin
edit_memory:
	jsr		edit_mem_sub
	bra		begin
block_fill:
	jsr		block_fill_sub
	bra		begin
download:
	jsr		download_sub
	bra		begin
	

; ---- TEXT ----

msg_1		dc.b	"Monitor v1.2 (c)2001 POM/U. Florida",13,10,0
menu_1		dc.b	"1 - View memory",13,10,0
menu_2		dc.b	"2 - Edit memory",13,10,0
menu_3		dc.b	"3 - Block fill",13,10,0
menu_4		dc.b	"4 - Download S19",13,10,0
prompt		dc.b	"Enter selection: ",0
newline		dc.b	13,10,0

vm_1		dc.b	"Enter starting address: ",0
vm_2		dc.b	"Enter end address: ",0
bf_1		dc.b	"Fill with number (hex): ",0
em_1		dc.b	"Edit memory location: ",0
em_2		dc.b	"Old value: ",0
em_3		dc.b	"New value: ",0
ds_wait     dc.b    13,10,"Waiting for S19 download ... ",0
ds_done		dc.b	"done!",13,10,0

; ---- SUBROUTINES ----


;---------------- VIEW MEMORY SUBROUTINE ---------------
view_mem_sub:
	ldy		#newline
	jsr		print_string
	ldy		#vm_1
	jsr		print_string
	jsr		get_address

	;jsr		print_address		; DEBUG

	pshx	

	ldy 	#newline
	jsr		print_string
	ldy		#vm_2
	jsr		print_string
	jsr		get_address
	puld	

	;jsr	print_address			; DEBUG

	; round down the lower address
	andb	#%11110000
	xgdx	
	; round up the upper address (in D right now)
	pshd
	andb	#%00001111
	ldaa	#$0f
	sba
	adda 	#1
	psha				; such a damn hack
	pulb				;
	clra				;
	std	tempw2
	puld	
	addd	tempw2

	std		tempw		; store D -- the upper address

	;xgdx				; D is now the lower and X the upper

loop1:
	ldy		#newline
	jsr		print_string
	
	jsr		print_address
	ldaa	#':'
	jsr		put_char
	ldaa	#32
	jsr		put_char
loop2:
	cpx		tempw
	beq		vms_done

	ldaa	0,x			; load the number at the location
	jsr		print_number
	ldaa	#32			; space
	jsr		put_char

	pshx
	puld	
	andb	#%00001111
	cmpb	#$0F
	beq		vms_newline
	bra		vms_blah	
vms_newline:
	inx
	bra		loop1
vms_blah:
	inx	
	bra		loop2
vms_done:
	ldy		#newline
	jsr		print_string
	rts

;-----------------= EDIT MEMORY SUBROUTINE =------------------

edit_mem_sub:
     ldy       #newline
     jsr       print_string
     
     ldy       #em_1
     jsr       print_string

     jsr       get_address         ; returns address in X

     ldaa      0,x                 ; get the old value
     ldy       #newline
     jsr       print_string
     ldy       #em_2               ; "Old value: "
     jsr       print_string	

     jsr       print_number        ; prints whats in A

     ldy       #newline
     jsr       print_string
     
     ldy       #em_3               ; "New value: "
     jsr       print_string

     jsr       get_byte

     staa      0,x                 ; put the new number into
                                   ; that memory location
     rts                           ; done

;------------------= BLOCK FILL SUBROUTINE =-------------------

block_fill_sub:
     ldy       #newline  
     jsr       print_string
     
     ldy       #vm_1               ; "Enter starting address:"
     jsr       print_string        ;
     
     jsr       get_address         ; get the start addr
     pshx                          ; and store it
     
     ldy       #newline  
     jsr       print_string      

     ldy       #vm_2               ; "enter end address: "
     jsr       print_string
     jsr       get_address         ; get teh end addr
     pshx                          ; and put it away

     ldy       #newline  
     jsr       print_string
     
     ldy       #bf_1               ; "Fill with number (hex): "
     jsr       print_string
     
     jsr       get_byte          ; returns number in A

     pulx      ; pull off the high address (end)
     psha      ; save it
     xgdx      ; D is now the high addr
     std       tempw               ; save it in RAM
     
     pula      ; restore it
     pulx      ; the low addr

bf_loop:
     staa      0,x                 ; put the number into mem
     inx       
     cpx       tempw               ; compare it with memory
     bgt       bf_done             ; branch to done if >= end addr
     bra       bf_loop             ; otherwise continue
bf_done:
	rts

; --------------= S19 DOWNLOAD Subroutine =----------------

download_sub:
	ldy        #ds_wait				; "waiting for S19 download"
	jsr        print_string			;

	; wait for S
S_wait:
	jsr        get_char_wait_noecho
	cmpa       #'S'
	bne        S_wait

	; wait for a '1' but exit if 9
one_wait:
	jsr        get_char_wait_noecho
	cmpa       #'9'
	beq        d_done
	cmpa       #'1'
	bne        one_wait

	; get the count and remove 3 for chksum and address
	; it is returned in A
	jsr        get_byte_ne
	suba       #3
	; put it into B
	psha
	pulb

	; get the address (4 bytes)
	; it is returned in X
	jsr        get_address

d_loop1:
	; get the stuff!
	jsr        get_byte_ne
	; store it
	staa       0,x

	; increment X -- address
	inx
	; decrement B and check if it is zero
	decb
	beq        S_wait
	bra        d_loop1

d_done:
	ldy        #ds_done
	jsr        print_string
	rts

;--------- UTILITY ROUTINES! -----------

;	get the user's selection and
;	check it for bad number
get_selection:
	jsr		get_char_wait	; register A is the selection
	cmpa	#$31			; $31 = '1'
	blt		get_selection	; if < 1 try again
	cmpa	#$34			; $34 = '4'
	bgt		get_selection	; if > 4 try again
	rts

; return user address input in X
;
get_address:
	pshb
	bsr		get_number
	lsla	
	lsla
	lsla
	lsla
	psha
	bsr		get_number
	pulb
	aba	
	psha
	bsr		get_number
	lsla
	lsla
	lsla
	lsla
	psha
	bsr		get_number
	pulb					
	aba
	psha
	pulb
	pula
	xgdx	; put address in X
	pulb
	rts

get_address_ne:
	pshb
	bsr		get_number_ne
	lsla	
	lsla
	lsla
	lsla
	psha
	bsr		get_number_ne
	pulb
	aba	
	psha
	bsr		get_number_ne
	lsla
	lsla
	lsla
	lsla
	psha
	bsr		get_number_ne
	pulb					
	aba
	psha
	pulb
	pula
	xgdx	; put address in X
	pulb
	rts


; Now this get_number subroutine actually returns a
; single hex number 0-15. It does not do a hex
; double -- that is the get_byte subroutine.
get_number:
	jsr		get_char_wait
	cmpa	#$39
	bgt		alpha_	
	suba	#$30
	bra		over_alpha_
alpha_:
	;suba	#55
	anda	#$0f
	adda	#9
over_alpha_:
	rts

get_number_ne:
	jsr		get_char_wait_noecho
	cmpa	#$39
	bgt		alpha_ne	
	suba	#$30
	bra		over_alpha_ne
alpha_ne:
	anda	#$0f
	adda	#9
over_alpha_ne:
	rts


print_splash:
	ldy		#newline
	jsr		print_string
	ldy		#msg_1
	jsr		print_string
	ldy		#newline
	jsr		print_string
	rts

; get_byte
; waits for two numbers (in hex)
; to be entered and returns the
; result in A
get_byte:
	pshb
	bsr		get_number
	lsla
	lsla	
	lsla
	lsla	
	psha
	bsr		get_number
	pulb
	aba
	pulb
	rts

get_byte_ne:
	pshb
	bsr		get_number_ne
	lsla
	lsla	
	lsla
	lsla	
	psha
	bsr		get_number_ne
	pulb
	aba
	pulb
	rts

print_menu:
	ldy		#newline
	bsr		print_string
	ldy		#menu_1
	bsr		print_string
	ldy		#menu_2
	bsr		print_string
	ldy		#menu_3
	bsr		print_string
	ldy		#menu_4
	bsr		print_string	
	ldy		#newline
	bsr		print_string
	ldy		#prompt
	bsr		print_string
	rts

#include "serial.asm"

#include "cop.asm"
