; 
; 6812 monitor 1.3
; Feb 12, 2001
; Mar 21, 2001 updated (works fully)
; Dec 10, 2001 added breakpoint stuff while in a motel in Tallahassee
;		after visiting historic Doak Campbell Stadium at FSU.
;		I'm not impressed. Their campus is so dirty. The inside
;		of all their buildings looks like the basement of ours.
; Patrick O'Malley
; University of Florida/Machine Intelligence Lab
; 
; Notes:
; Some of this code is ugly. The _ne subroutines, for
; example. These do no echo back to the screen. Why?
; because of some dumb stuff. They can all be removed
; if you really want. I'm too lazy. 
;
; Yes, there is a dumb bug in the view memory
; thing so that it prints out an extra "address:"
; Again -- too lazy to fix.
;
; This was written for the EEL4744 course which is/was
; changed over to the 6812 from the 6811. Yeah, a dumb
; change but whatever -- it wasn't my decision.
;
; For some strange reason, using the ASCII upload in 
; minicom for Linux will NOT work with the S19 
; downloader subroutine. However, just do a 
; "cat file.s19 > /dev/ttyS0" and it will work fine.
; I don't know why minicom messes up.
;
; This code will compile with the old 6811 assembler.
;
;

; ----- HARDCODED INTERRUPT VECTORS! -----
; set the SWI interrupt vector before I forget
	org	$FFF6
SWI	dw	swi_handler	
	
; set the reset interrupt vector
	org	$FFFE
RESET	dw	$E000

; set the rest of the vectors to the pseudo-vectors (fake vectors)
; that I set up below
; mental note: remember to add the rest of them because the book didn't
; have the "peripheral" interrupts. need to get the manual for the B32
; and use those. easy addition.

	org	$FFFC
CLKRST		dw	v_clk_mon_rst

	org	$FFFA
COPINT		dw	v_COP

	org	$FFF8
TRAPRST		dw	v_trap

	org	$FFF4
XIRQRST		dw	v_XIRQ

	org	$FFF2
IRQRST		dw	v_IRQ

;----- MISC EQUATES -----

PEAR		equ	$000A	; Port-E Assignment Register
MODE		equ	$000B

; ---- FAKE INTERRUPT VECTORS! ----

	org	$0800

v_reset		zmb	3
v_clk_mon_rst	zmb	3
v_COP		zmb	3
v_trap		zmb	3
v_SWI		zmb	3
v_XIRQ		zmb	3
v_IRQ		zmb	3

; ---- START ----

; temporary storage space
tempw		dc.w		$0000
tempw2		dc.w		$0000
bkpt_table	zmb		10		; the addresses of the breakpoints
bkpt_tbl_code	zmb		5		; the code that used to be where the SWIs are now
bkpt_num	dc.b		$00		; bkpt table ptr
SP_save		dc.w		user_stack_top	; a place to save the user's SP when SWI occurs
SP_save_mon	dc.w		$0000		; a place to save the monitor's SP (why??)
SWI_flag	dc.b		$00		; I'm not going to explain this one!
test_buffer	zmb		20

; the monitor's stack is 32 bytes (should be enough)
; and is located here, at the top of the internal RAM.
; user stack can be just below it. user_stack_top
; is here just for reference! its never used specifically!

	org	$0bff
mon_stack_top	equ	*

	org	$0bdf
user_stack_top	equ	*

	
; ----- MONITOR RESET ENTRY -----
; reset vector jumps to here!

	org		$e000

	lds		#mon_stack_top		; setup the stack pointer
	jsr		cop_off			; turn off the COP reset gen
	jsr		init_serial_tx_rx	; start the serial system, duh.

	; since SP_save is in RAM and we don't control that, lets
	; make sure its OK by putting the address of user_stack_top 
	; into SP_save

	ldx		#user_stack_top
	stx		SP_save

	; clear the bkpt counter (just in case)
	clra
	staa		bkpt_num	

; the following 3 lines change the MODE register to 
; keep it from doing th at clock stretching thing. It
; doesn't work (with the proto board) but I want to
; leave it here for reference.
;	ldaa		MODE
;	anda		#%11101111
;	staa		MODE
		
	; the next two lines enable RAM R/W
	; or it won't work!
	ldaa		#%00000100      ;Enable R/W
	staa		PEAR

; print the splash screen and the menu
begin:
	jsr		print_splash
	jsr		print_menu
	jsr		get_selection		; returns a selection in A
;	ldx		#test_buffer		; DEBUG
;	jsr		get_line		; DEBUG
;	pshx					; DEBUG
;	puly					; DEBUG
;	jsr		print_string		; DEBUG
	
	cmpa	#$31				; view memory
	beq		view_memory		
	cmpa	#$32				; edit memory
	beq		edit_memory		;
	cmpa	#$33				; block fill 
	beq		block_fill		;
	cmpa	#$35	
	beq		add_bkpt		; add a breakpoint to the table
	cmpa	#$36	
	beq		write_bkpt_t		; write the bkpt table to the memory
	cmpa	#$37	
	beq		reg_view		; register view
	cmpa	#$34
	beq		download		; S19 download
	cmpa	#$38	
	beq		go_addr			; execute user code starting at addr
	cmpa	#$39	
	beq		print_bkpt		; print breakpoint table

	bra		begin			; fall through

view_memory:
	jsr		view_mem_sub
	bra		begin
edit_memory:
	jsr		edit_mem_sub
	bra		begin
block_fill:
	jsr		block_fill_sub
	bra		begin
add_bkpt:
	jsr		add_bkpt_sub		
	bra		begin
write_bkpt_t:
	jsr		begin
	bra		begin			; CHANGE THIS! DUH!
reg_view:
	jsr		reg_view_sub
	bra		begin
download:
	jsr		download_sub
	bra		begin
go_addr:	
	jsr		go_addr_sub
	bra		begin	

print_bkpt:
	jsr		print_bkpt_sub
	bra		begin

; ---- TEXT ----

msg_1		dc.b	"Monitor v1.3 (c)2001 POM/U. Florida",13,10,0
menu_0		dc.b	"0 - Resume Execution",13,10,0
menu_1		dc.b	"1 - View memory",13,10,0
menu_2		dc.b	"2 - Edit memory",13,10,0
menu_3		dc.b	"3 - Block fill",13,10,0
menu_4		dc.b	"4 - Download S19",13,10,0
menu_5		dc.b	"5 - Add a Breakpoint",13,10,0
menu_6		dc.b	"6 - Remove a Breakpoint",13,10,0
menu_7		dc.b	"7 - Register View",13,10,0
menu_8		dc.b	"8 - Execute (Go)",13,10,0
menu_9		dc.b	"9 - View Breakpoint Table",13,10,0
prompt		dc.b	"Enter selection: ",0
newline		dc.b	13,10,0

vm_1		dc.b	"Enter starting address: ",0
vm_2		dc.b	"Enter end address: ",0
bf_1		dc.b	"Fill with number (hex): ",0
em_1		dc.b	"Edit memory location: ",0
em_2		dc.b	"Old value: ",0
em_3		dc.b	"New value: ",0
ds_wait		dc.b    13,10,"Waiting for S19 download ... ",0
ds_done		dc.b	"done!",13,10,0
go_addr_msg	dc.b	"Address: ",0




; ---- SUBROUTINES ----

; ---- SWI SUBROUTINE! ----
; this is where the SWI interrupt gets processed
swi_handler:
	; copy the SP (user's SP) to the RAM location for it
	tsx					; transfer SP into X
	xgdx					; exchange X with D so I can do a STDD
	std		SP_save			; save SP

	; change SP to the monitor's SP	
	lds		SP_save_mon		; I wonder if this is really necessary

	; jump to the monitor's start to get things running (how dumb!)
swi_done:
	jmp		begin


;---------------- VIEW MEMORY SUBROUTINE ---------------
view_mem_sub:
	ldy		#newline
	jsr		print_string
	ldy		#vm_1
	jsr		print_string
	jsr		get_address

	;jsr		print_address		; DEBUG

	pshx	

	ldy 		#newline
	jsr		print_string
	ldy		#vm_2
	jsr		print_string
	jsr		get_address
	puld	

	;jsr		print_address		; DEBUG

	; round down the lower address
	andb		#%11110000
	xgdx	
	; round up the upper address (in D right now)
	pshd
	andb		#%00001111
	ldaa		#$0f
	sba
	adda 		#1
	psha					; such a damn hack
	pulb					;
	clra					;
	std		tempw2
	puld	
	addd		tempw2

	std		tempw			; store D -- the upper address

	;xgdx					; D is now the lower and X the upper

loop1:
	ldy		#newline
	jsr		print_string
	
	jsr		print_address
	ldaa		#':'
	jsr		put_char
	ldaa		#32
	jsr		put_char
loop2:
	cpx		tempw
	beq		vms_done

	ldaa		0,x			; load the number at the location
	jsr		print_number
	ldaa		#32			; space
	jsr		put_char

	pshx
	puld	
	andb		#%00001111
	cmpb		#$0F
	beq		vms_newline
	bra		vms_blah	
vms_newline:
	inx
	bra		loop1
vms_blah:
	inx	
	bra		loop2
vms_done:
	ldy		#newline
	jsr		print_string
	rts


;--------------------= "GO" SUBROUTINE =---------------------

; The "go" routine just does a JMP to where the user says. It doesn't
; mess with the stack (other than to set SP to the user's stack)
; the "resume" function does an rts using the stack to get to user's 
; code after an SWI, for example. Use that for breakpoints.
go_addr_sub:
	ldy		#newline
	jsr		print_string
	ldy		#go_addr_msg
	jsr		print_string

	jsr		get_address		; returns address in X
	pshx
	puly					; put the address in Y		

	; save the monitor's stack. set SP to user's
	tsx	
	xgdx
	std		SP_save_mon

	lds		SP_save
	
	; now jump to the location in Y
	jmp		0,y


;-----------------= EDIT MEMORY SUBROUTINE =------------------

edit_mem_sub:
	
     pshy 
     pshx
     pshd
	
     ldy       #newline
     jsr       print_string
     
     ldy       #em_1
     jsr       print_string

     jsr       get_address         ; returns address in X

     ldaa      0,x                 ; get the old value
     ldy       #newline
     jsr       print_string
     ldy       #em_2               ; "Old value: "
     jsr       print_string	

     jsr       print_number        ; prints whats in A

     ldy       #newline
     jsr       print_string
     
     ldy       #em_3               ; "New value: "
     jsr       print_string

     jsr       get_byte

     staa      0,x                 ; put the new number into
                                   ; that memory location
     
     puld                          ; restore the registers
     pulx
     puly 

     rts                           ; done

;------------------= BLOCK FILL SUBROUTINE =-------------------

block_fill_sub:
     pshy
     pshx
     pshd

     ldy       #newline  
     jsr       print_string
     
     ldy       #vm_1               ; "Enter starting address:"
     jsr       print_string        ;
     
     jsr       get_address         ; get the start addr
     pshx                          ; and store it
     
     ldy       #newline  
     jsr       print_string      

     ldy       #vm_2               ; "enter end address: "
     jsr       print_string
     jsr       get_address         ; get teh end addr
     pshx                          ; and put it away

     ldy       #newline  
     jsr       print_string
     
     ldy       #bf_1               ; "Fill with number (hex): "
     jsr       print_string
     
     jsr       get_byte          ; returns number in A

     pulx			; pull off the high address (end)
     psha			; save it (the fill number)
     xgdx			; D is now the high addr
     std       tempw               ; save it in RAM
     
     pula      ; restore it (the number to fill with)
     pulx      ; the low addr (get the low addr)

bf_loop:
	staa	0,x                 ; put the number into mem
	inx       
	cpx	tempw               ; compare it with memory
	bgt	bf_done             ; branch to done if >= end addr
	bra	bf_loop             ; otherwise continue
bf_done:
	puld
	pulx
	puly
	rts

; --------------= Print Breakpoint Table Sub =-------------
print_bkpt_sub:
	ldy		#newline
	jsr		print_string

	ldab		bkpt_num		; load the bkpt counter
	beq		pb_done			; if its zero, no breakpoints to print
	
	ldx		#bkpt_table
	ldy		#bkpt_tbl_code		
	
pb_loop1:
	pshb					; save the counter
	ldd		0,x			; load the address in the table
	xgdx					; d <-> x
	jsr		print_address		; print the address
	xgdx	

	ldaa		#32			; space
	jsr		put_char
	
	ldaa		0,y			; a is now the code it replaced
	jsr		print_number		; print it

	pshy
	ldy		#newline		
	jsr		print_string	
	puly

	inx					; X needs to increment two each time
	inx
			
	iny					; Y only needs to increment once

	pulb					; get the counter back
	
	decb					
	beq		pb_done			; zero?
	bra		pb_loop1
pb_done:
	rts


; --------------= Breakpoint Add Subroutine =--------------
add_bkpt_sub:
	; see if we have room in the bkpt table
	ldaa		bkpt_num
	cmpa		#5
	bge		no_room
	
	; first, get the address we'll add the bkpt at
	ldy		#newline	
	jsr		print_string
	
	ldy		#go_addr_msg
	jsr		print_string
		
	jsr		get_address		; get the address in X
	pshx					; save it for later
	
	; now we need to get the byte at that location
	; put it into the bkpt table and put an SWI in its place
	ldaa		0,x			; get the code byte
	; figure out where in the bkpt_table to put the code and address
	ldab		bkpt_num
	ldx		#bkpt_tbl_code
	abx					; x is now the location in bkpt_tble_code to put the code
	staa		0,x			; put it in the code table
	
	ldx		#bkpt_table		
	aslb					; multiply the bkpt_num by two
	abx					; and add it to X -- this is the location
						; in bkpt_table to put the address

	puly					; pulls off the bkpt address
	xgdy					; put Y (the bkpt addr) into D
	std		0,x			; put that address in the bkpt table at the right place!
	xgdy					; switch it back (this is ugly!)

	ldaa		#$3f			; $3f=SWI opcode
	staa		0,y			; put SWI there

	inc		bkpt_num		; increment the bkpt counter

no_room:
	rts


; --------------= Register View Subroutine =---------------
;reglist	dc.b	'PYXABCS'		; names
;	dc.b	1,1,1,0,0,0,1			; size
reglist	dc.b	'CBAXYP'
	dc.b	0,0,0,1,1,1

reg_view_sub:
	; this subroutine displays the registers stored on the 
	; user's stack after (for example) an SWI.

	ldy		#newline
	jsr		print_string

	ldy		SP_save			; load Y with the user's SP
	ldx		#reglist		; load X with the stuff we need to use
	ldaa		#6
rv_loop1:
	ldab		6,x			; load B with the size of the register to be printed
	cmpb		#$00			; 
	bgt		rv_double		; if its a '1' its a double!
rv_single:
	psha
	ldaa		0,x
	jsr		put_char
	ldaa		#'-'
	jsr		put_char
	ldaa		0,y
	jsr		print_number
	pula
	iny
	inx
	bra		rv_loop_end
rv_double:
	psha
	ldaa		0,x
	jsr		put_char
	ldaa		#'-'
	jsr		put_char
	pula
	pshx
	ldx		0,y
	jsr		print_address
	pulx
	iny
	iny
	inx
rv_loop_end:
	psha
	ldaa		#32
	jsr		put_char
	pula
	deca
	beq		rv_done
	bra		rv_loop1
rv_done:
	rts

; --------------= S19 DOWNLOAD Subroutine =----------------

download_sub:
	ldy        #ds_wait			; "waiting for S19 download"
	jsr        print_string			;

	; wait for S
S_wait:
	jsr        get_char_wait_noecho
	cmpa       #'S'
	bne        S_wait

	; wait for a '1' but exit if 9
one_wait:
	jsr        get_char_wait_noecho
	cmpa       #'9'
	beq        d_done
	cmpa       #'1'
	bne        one_wait

	; get the count and remove 3 for chksum and address
	; it is returned in A
	jsr        get_byte
	suba       #3
	; put it into B
	psha
	pulb

	; get the address (4 bytes)
	; it is returned in X
	jsr        get_address

d_loop1:
	; get the stuff!
	jsr        get_byte
	; store it
	staa       0,x

	; increment X -- address
	inx
	; decrement B and check if it is zero
	decb
	beq        S_wait
	bra        d_loop1

d_done:
	ldy        #ds_done
	jsr        print_string
	rts

;--------- UTILITY ROUTINES! -----------

;	get the user's selection and
;	check it for bad number
get_selection:
	jsr		get_char_wait	; register A is the selection
	cmpa	#$31			; $31 = '1'
	blt		get_selection	; if < 1 try again
	cmpa	#$39			; $37 = '7'
	bgt		get_selection	; if > 7 try again
	rts

; return user address input in X
;
get_address:
	pshb
	bsr		get_number
	lsla	
	lsla
	lsla
	lsla
	psha
	bsr		get_number
	pulb
	aba	
	psha
	bsr		get_number
	lsla
	lsla
	lsla
	lsla
	psha
	bsr		get_number
	pulb					
	aba
	psha
	pulb
	pula
	xgdx	; put address in X
	pulb
	rts

;get_address_ne:
;	pshb
;	bsr		get_number_ne
;	lsla	
;	lsla
;	lsla
;	lsla
;	psha
;	bsr		get_number_ne
;	pulb
;	aba	
;	psha
;	bsr		get_number_ne
;	lsla
;	lsla
;	lsla
;	lsla
;	psha
;	bsr		get_number_ne
;	pulb					
;	aba
;	psha
;	pulb
;	pula
;	xgdx	; put address in X
;	pulb
;	rts


; Now this get_number subroutine actually returns a
; single hex number 0-15. It does not do a hex
; double -- that is the get_byte subroutine.
get_number:
	jsr		get_char_wait
	cmpa	#$39
	bgt		alpha_	
	suba	#$30
	bra		over_alpha_
alpha_:
	;suba	#55
	anda	#$0f
	adda	#9
over_alpha_:
	rts

;get_number_ne:
;	jsr		get_char_wait_noecho
;	cmpa	#$39
;	bgt		alpha_ne	
;	suba	#$30
;	bra		over_alpha_ne
;alpha_ne:
;	anda	#$0f
;	adda	#9
;over_alpha_ne:
;	rts


print_splash:
	ldy		#newline
	jsr		print_string
	ldy		#msg_1
	jsr		print_string
	ldy		#newline
	jsr		print_string
	rts

; get_byte
; waits for two numbers (in hex)
; to be entered and returns the
; result in A
get_byte:
	pshb
	bsr		get_number
	lsla
	lsla	
	lsla
	lsla	
	psha
	bsr		get_number
	pulb
	aba
	pulb
	rts

;get_byte_ne:
;	pshb
;	bsr		get_number_ne
;	lsla
;	lsla	
;	lsla
;	lsla	
;	psha
;	bsr		get_number_ne
;	pulb
;	aba
;	pulb
;	rts

print_menu:
;	ldy		#newline
;	bsr		print_string
	ldy		#menu_1
	jsr		print_string
	ldy		#menu_2
	jsr		print_string
	ldy		#menu_3
	jsr		print_string
	ldy		#menu_4
	jsr		print_string
	ldy		#menu_5
	jsr		print_string
	ldy		#menu_7
	jsr		print_string
	ldy		#menu_8
	jsr		print_string	
	ldy		#menu_9
	jsr		print_string
	ldy		#newline
	jsr		print_string
	ldy		#prompt
	jsr		print_string
	rts

; get_line subroutine gets a line of text from the serial port
; and puts it in a buffer starting at the address in X. The
; "end of line" is a CRLF (13,10). You can prevent buffer overflows
; by making B = # of chars that, if the user enters that many, will
; automatically cause this sub to return
get_line:
	pshx					; lets push X to keep it unchanged so you could print it
gl_loop1:
	jsr		get_char_wait		; returns the character in A
	cmpa		#13			; only need to check for a 10 (LF)
	beq		gl_done			; if its a 10, return
	staa		0,x			; otherwise store it in X
	inx					; increment X
	bra		gl_loop1		; continue
gl_done:
	staa		0,x			; store the 10 -- need it, I guess
	inx
	clra		
	staa		0,x			; put a zero at the end of the line to indicate eol
	pulx					; restore X
	rts



; ----- TEST CODE! -----
testcode:
	ldaa	#$aa
	ldab	#$01
	ldx	#$0505
	ldy	#$5050

	swi
	rts

#include "serial.asm"

#include "cop.asm"
